/*
 * Program        : qsort.h
 *
 * Objectives     : to implement some necessary functions in sorting
 *
 * Assumptions    : Item ID in dataset file should start from zero.
 *                  I.e. if there are NUM items in the dataset, 
 *                  the item ID should be from 0 to NUM-1.
 *
 * Variations     : 
 *
 * Platform       : SunOS/Linux
 * Compiler       : gcc
 *
 * Programmer     : Raymond Chi-Wing Wong
 * Creation Date  : Oct, 2002
 * Last Update    : Jun 9, 2004
 *
 *      
 */


#ifndef QSORT_H
#define QSORT_H

#include <stdio.h>
#include <stdlib.h>

// decreasing order
void q_swap(int *sorted_index, double *value, int i, int j);
int partition(int *sorted_index, double *value, int start_index, int end_index);
void quicksort(int *sorted_index, double *value, int start_index, int end_index);

void q_swap_i(int *sorted_index, int *value, int i, int j);
int partition_i(int *sorted_index, int *value, int start_index, int end_index);
void quicksort_i(int *sorted_index, int *value, int start_index, int end_index);

void q_swap_i_indShort(short *sorted_index, int *value, int i, int j);
int partition_i_indShort(short *sorted_index, int *value, int start_index, int end_index);
void quicksort_i_indShort(short *sorted_index, int *value, int start_index, int end_index);




#endif
